// vcmail2003Dlg.cpp : t@C
//

#include "stdafx.h"
#include "vcmailnet.h"
#include "vcmailnetDlg.h"
#include ".\vcmailnetdlg.h"
#include "Input.h"
#include "Option.h"
#include "Create.h"
#include "Unite.h"

#include "nMail.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define INI_SECTION			_T("VCMAIL")
#define INI_APOP			_T("APOP")
#define INI_SMTP			_T("SMTP")
#define INI_POP3			_T("POP3")
#define INI_MAIL_ADDRESS	_T("MAIL_ADDRESS")

// Cvcmail2003Dlg _CAO



CvcmailnetDlg::CvcmailnetDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CvcmailnetDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_splitter = NULL;
}

void CvcmailnetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_MAIL, m_lmail);
	DDX_Control(pDX, IDC_EDIT_BODY, m_ebody);
}

BEGIN_MESSAGE_MAP(CvcmailnetDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_WM_INITMENUPOPUP()
	ON_NOTIFY(NM_CLICK, IDC_LIST_MAIL, OnNMClickListMail)
	ON_NOTIFY(NM_RCLICK, IDC_LIST_MAIL, OnNMRclickListMail)
	ON_WM_CTLCOLOR()
	ON_COMMAND(IDM_CREATE, OnCreate)
	ON_COMMAND(IDM_DELETE, OnDelete)
	ON_UPDATE_COMMAND_UI(IDM_DELETE, OnUpdateDelete)
	ON_COMMAND(IDM_EXIT, OnExit)
	ON_COMMAND(IDM_NEW, OnNew)
	ON_COMMAND(IDM_OPTION, OnOption)
	ON_COMMAND(IDM_RE, OnRe)
	ON_UPDATE_COMMAND_UI(IDM_RE, OnUpdateRe)
	ON_COMMAND(IDM_SAVE, OnSave)
	ON_UPDATE_COMMAND_UI(IDM_SAVE, OnUpdateSave)
	ON_COMMAND(IDM_UNITE, OnUnite)
	ON_WM_SIZE()
END_MESSAGE_MAP()


// CvcmailnetDlg bZ[W nh

BOOL CvcmailnetDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// INI t@CǍ
	ReadIni();

	// ݒ
	m_splitter = new CSplitter();
	m_splitter->CreateSplitter(30, this, &m_lmail, &m_ebody, true);

	CRect rc;
	GetClientRect(rc);
	// s]ݒ
	m_lmail.SetExtendedStyle(LVS_EX_FULLROWSELECT);
	// XgRg[̃wb_ݒ
	m_lmail.InsertColumn(0, _T(""), LVCFMT_LEFT, (int)(rc.right * 50) / 100);
	m_lmail.InsertColumn(1, _T("ol"), LVCFMT_LEFT, (int)(rc.right * 30) / 100);
	m_lmail.InsertColumn(2, _T("t"), LVCFMT_LEFT, (int)(rc.right * 15) / 100);
	
	m_body_brush.CreateSolidBrush(RGB(255, 255, 255));

    // Winsock 
    NMailInitializeWinSock();

    // ^CAEg̓ftHg(30b)
    // wb_ől 8192
    // {ől͖
    //NMailSetParameter(0, HEADER_MAX, 0);
    NMailSetOption(NMAIL_OPTION_HEADER_MAX, HEADER_MAX);

	// [ꗗǍ
	PostMessage(WM_COMMAND, IDM_NEW);

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CvcmailnetDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//[U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CvcmailnetDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CvcmailnetDlg::OnBnClickedOk()
{
//	OnOK();
}

void CvcmailnetDlg::OnBnClickedCancel()
{
	OnCancel();
}

void CvcmailnetDlg::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu)
{
	CDialog::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);

	CCmdUI cmdUI;
	cmdUI.m_pMenu = pPopupMenu;
	cmdUI.m_nIndexMax = pPopupMenu->GetMenuItemCount();
	for (cmdUI.m_nIndex = 0 ; cmdUI.m_nIndex < pPopupMenu->GetMenuItemCount() ; cmdUI.m_nIndex++) {
		if(!(cmdUI.m_nID = pPopupMenu->GetMenuItemID(cmdUI.m_nIndex))) {
			continue;
		} else if(cmdUI.m_nID == (UINT)-1) {
			cmdUI.m_pSubMenu = pPopupMenu->GetSubMenu(cmdUI.m_nIndex);
			if(!cmdUI.m_pSubMenu || !(cmdUI.m_nID = cmdUI.m_pSubMenu->GetMenuItemID(0)) || (cmdUI.m_nID == (UINT)-1)) {
				continue;
			}
			cmdUI.DoUpdate(this, FALSE);
		} else {
			cmdUI.m_pSubMenu = NULL;
			cmdUI.DoUpdate(this, cmdUI.m_nID < 0xF000);
		}
	}

}

void CvcmailnetDlg::OnNMClickListMail(NMHDR *pNMHDR, LRESULT *pResult)
{
	NM_LISTVIEW *pNMListView = (NM_LISTVIEW *)pNMHDR;
	int no = pNMListView->iItem;

	if(no != -1) {
		TCHAR subject[HEADER_MAX];
		TCHAR date[HEADER_MAX];
		TCHAR from[HEADER_MAX];
		TCHAR header[HEADER_MAX];
		CString body;
		int size;

		// Ă킩邩Ǝv܂AM̂тɐڑĂ܂B
		// {ł ID pX[h͌AxɎMA
		// T[o[ォM[폜At@C
		// ۑĂA薼ꗗNbNł́AۑĂ郁[
		// ǂݍޏׂł傤B

		// fR[hL
		NMailSetOption(NMAIL_OPTION_DECODE_BODY, NMAIL_DECODE_BODY_ON);
		// HTML p[g͕ۑȂ
		NMailSetOption(NMAIL_OPTION_SAVE_HTML, NMAIL_SAVE_HTML_OFF);

		// POP3 T[o[ɐڑ
		SOCKET s;
		if((s = NMailPop3Connect(m_pop3)) != INVALID_SOCKET) {
			// IĂԍA[̐菭ȂH
			if(no < NMailPop3Authenticate(s, m_id, m_password, m_apop)) {
				// [̃TCY𓾂āAm
				size = NMailPop3GetMailSize(s, no + 1) * 2;
				// [̓ǂݍ
				NMailPop3GetMail(s, no + 1, subject, date, from, header, body.GetBuffer(size + 1), NULL, NULL);
				body.ReleaseBuffer();
				// \p Memo NAĎMeǉ
				m_ebody.SetWindowText(body);
			}
			// ڑI
			NMailPop3Close(s);
		}
	}
	*pResult = 0;
}

void CvcmailnetDlg::OnNMRclickListMail(NMHDR *pNMHDR, LRESULT *pResult)
{
	CMenu pm, *sm;
	POINT pt;

	if(m_lmail.GetSelectedCount() > 0) {
		pm.LoadMenu(IDR_MENU_POPUP);
		sm = pm.GetSubMenu(0);
		GetCursorPos(&pt);
		sm->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, this);
	}
	*pResult = 0;
}

HBRUSH CvcmailnetDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if(pWnd == &m_ebody) {
		pDC->SetBkMode(OPAQUE);
		pDC->SetBkColor(RGB(255, 255, 255));
		return (HBRUSH)m_body_brush;
	}
	return hbr;
}

BOOL CvcmailnetDlg::DestroyWindow()
{	
	delete m_splitter;
	DeleteListItem();
	// ݒۑ
	WriteIni();
	return CDialog::DestroyWindow();
}

void CvcmailnetDlg::PostNcDestroy()
{
	//delete m_splitter;	
	CDialog::PostNcDestroy();
}

void CvcmailnetDlg::OnCreate()
{
	CCreate dlg(this);

	if(dlg.DoModal() == IDOK) {
		int ret;
		TCHAR msg[HEADER_MAX];
		CFileStatus fs;
		// [M
		if(CFile::GetStatus(dlg.m_attach, fs)) {
			ret = NMailSmtpSendMail(m_smtp, dlg.m_to, NULL, NULL, m_mail_address, dlg.m_subject, dlg.m_body, NULL, dlg.m_attach, NMAIL_ENCODE_UTF8);
		} else {
			ret = NMailSmtpSendMail(m_smtp, dlg.m_to, NULL, NULL, m_mail_address, dlg.m_subject, dlg.m_body, NULL, NULL, 0);
		}
		if(ret < 0) {
			NMailGetMessage(NMAIL_GET_ERROR_MESSAGE, msg, HEADER_MAX);
            MessageBox(msg);
		}
	}
}

void CvcmailnetDlg::OnDelete()
{
	int no = m_lmail.GetNextItem(-1, LVNI_SELECTED);

	if(no != -1) {
        SOCKET s;
		// POP3 T[o[ɐڑ
        if((s = NMailPop3Connect(m_pop3)) != INVALID_SOCKET) {
            // [IԍH
            if(no < NMailPop3Authenticate(s, m_id, m_password, m_apop)) {
                // [폜
                NMailPop3DeleteMail(s, no + 1);
            }
            // ڑI
            NMailPop3Close(s);
        }
		// [ꗗXV
		OnNew();
	}
}

void CvcmailnetDlg::OnUpdateDelete(CCmdUI *pCmdUI)
{
	if(m_lmail.GetSelectedCount() == 0) {
		pCmdUI->Enable(FALSE);
	}
}

void CvcmailnetDlg::OnExit()
{
	CDialog::OnOK();
}

void CvcmailnetDlg::OnNew()
{
	int no, count;
	SOCKET s;
	TCHAR header[HEADER_MAX];
	TCHAR subject[HEADER_MAX];
	TCHAR date[HEADER_MAX];
	TCHAR from[HEADER_MAX];

	// POP3 ̐ݒ肪邩
	if(m_pop3.IsEmpty()) {
		OnOption();
		if(m_pop3.IsEmpty()) {
			return;
		}
	}
	// {\NA
	m_ebody.SetWindowText(_T(""));
	// ꗗ\NA
	DeleteListItem();
    
	if(m_id.IsEmpty() || m_password.IsEmpty()) {
		CInput idlg(this);
		// ID ƃpX[h
		if(idlg.DoModal() == IDOK) {
			m_id = idlg.m_id;
			m_password = idlg.m_password;
		} else {
			return;
		}
	}
	if((s = NMailPop3Connect(m_pop3)) != INVALID_SOCKET) {
		// [̐𓾂
		if((no = NMailPop3Authenticate(s, m_id, m_password, m_apop)) >= 0) {
			for(count = 1; count <= no ; count++) {
				// ԂɃwb_̓eǂ݁AListView ɒǉ
				NMailPop3GetMailStatus(s, count, subject, date, from, header, FALSE);
				m_lmail.InsertItem(count - 1, subject);
				m_lmail.SetItem(count - 1, 1, LVIF_TEXT, from, 0, 0, 0, 0);
				m_lmail.SetItem(count - 1, 2, LVIF_TEXT, date, 0, 0, 0, 0);
				CString *pstr = new CString(header);
				m_lmail.SetItemData(count - 1, (DWORD_PTR)pstr);
			}
		} else {
			NMailGetMessage(NMAIL_GET_ERROR_MESSAGE, subject, HEADER_MAX);
			MessageBox(subject);
		}
		NMailPop3Close(s);
	}
}

void CvcmailnetDlg::OnOption()
{
	// ݒ_CAO\
	COption dlg(this);

	dlg.m_pop3 = m_pop3;
	dlg.m_smtp = m_smtp;
	dlg.m_mail = m_mail_address;
	dlg.m_apop = m_apop;
	if(dlg.DoModal() == IDOK) {
		m_pop3 = dlg.m_pop3;
		m_smtp = dlg.m_smtp;
		m_mail_address = dlg.m_mail;
		m_apop = dlg.m_apop;
		// t@Cɕۑ
		WriteIni();
	}
}

void CvcmailnetDlg::OnRe()
{
	int no = m_lmail.GetNextItem(-1, LVNI_SELECTED);

	if(no != -1) {
		CCreate dlg(this);
		dlg.m_subject = _T("Re: ") + m_lmail.GetItemText(no, 0);  
		dlg.m_to = m_lmail.GetItemText(no, 1);  
		if(dlg.DoModal() == IDOK) {
			int ret;
			TCHAR msg[HEADER_MAX];
			CFileStatus fs;
			// [M
			if(CFile::GetStatus(dlg.m_attach, fs)) {
				ret = NMailSmtpSendMail(m_smtp, dlg.m_to, NULL, NULL, m_mail_address, dlg.m_subject, dlg.m_body, NULL, dlg.m_attach, 0);
			} else {
				ret = NMailSmtpSendMail(m_smtp, dlg.m_to, NULL, NULL, m_mail_address, dlg.m_subject, dlg.m_body, NULL, NULL, 0);
			}
			if(ret < 0) {
				NMailGetMessage(NMAIL_GET_ERROR_MESSAGE, msg, HEADER_MAX);
		        MessageBox(msg);
			}
		}
	}
}

void CvcmailnetDlg::OnUpdateRe(CCmdUI *pCmdUI)
{
	if(m_lmail.GetSelectedCount() == 0) {
		pCmdUI->Enable(FALSE);
	}
}

void CvcmailnetDlg::OnSave()
{
	int no = m_lmail.GetNextItem(-1, LVNI_SELECTED);

	if(no != -1) {
		CString name;

		name.Format(_T("mail%d.txt"), no);
		CFileDialog dlg(FALSE, _T("txt"), name, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("eLXgt@C(*.txt)|*.txt||"), this);
		if(dlg.DoModal() == IDOK) {
			// eLXgp[g Content-Transfer-Encoding fR[ĥݖ
			NMailSetOption(NMAIL_OPTION_DECODE_BODY, NMAIL_DECODE_BODY_TEXT_OFF);
			// HTML p[g̓t@CɕۑȂ
			NMailSetOption(NMAIL_OPTION_SAVE_HTML, NMAIL_SAVE_HTML_OFF);
			// POP3 T[o[ɐڑ
			SOCKET s;
			if((s = NMailPop3Connect(m_pop3)) != INVALID_SOCKET) {
				// IĂԍA[̐菭ȂH
				if(no < NMailPop3Authenticate(s, m_id, m_password, m_apop)) {//
					TCHAR subject[HEADER_MAX];
					TCHAR date[HEADER_MAX];
					TCHAR from[HEADER_MAX];
					TCHAR header[HEADER_MAX];
					CString body;
					int size;
					// [̃TCY𓾂āAm
					size = NMailPop3GetMailSize(s, no + 1) * 2;
					// [̓ǂݍ
					NMailPop3GetMail(s, no + 1, subject, date, from, header, body.GetBuffer(size + 1), NULL, NULL);
					body.ReleaseBuffer();

					CFile fi;
					if(fi.Open(dlg.GetPathName(), CFile::modeCreate | CFile::modeWrite)) {
						fi.Write(header, (UINT)(_tcslen(header) * sizeof(TCHAR)));
						fi.Write(_T("\r\n"), 2 * sizeof(TCHAR));
						fi.Write(body, body.GetLength() * sizeof(TCHAR));

						fi.Close();
					}
				}
			}
			// ڑI
			NMailPop3Close(s);
		}
	}
}

void CvcmailnetDlg::OnUpdateSave(CCmdUI *pCmdUI)
{
	if(m_lmail.GetSelectedCount() == 0) {
		pCmdUI->Enable(FALSE);
	}
}

void CvcmailnetDlg::ReadIni()
{
	TCHAR name[_MAX_PATH];
	TCHAR drive[_MAX_DRIVE];
	TCHAR directory[_MAX_DIR];
	TCHAR extension[_MAX_EXT];
	TCHAR fname[_MAX_FNAME];
	TCHAR temp[_MAX_PATH];

	GetModuleFileName(NULL, name, sizeof(name));
	GetCurrentDirectory(_MAX_PATH, m_current_path.GetBuffer(_MAX_PATH));
	m_current_path.ReleaseBuffer();
#if _MSC_VER < 1400
 #ifdef _UNICODE
	_wsplitpath(name, drive, directory, fname, extension);
 #else
	_splitpath(name, drive, directory, fname, extension);
 #endif
#else
 #ifdef _UNICODE
	_wsplitpath_s(name, drive, _MAX_DRIVE, directory, _MAX_DIR, fname, _MAX_FNAME, extension, _MAX_EXT);
 #else
	_splitpath_s(name, drive, _MAX_DRIVE, directory, _MAX_DIR, fname, _MAX_FNAME, extension, _MAX_EXT);
 #endif
#endif
	m_ini_path.Format(_T("%s\\%s.ini"), m_current_path, fname);

	m_apop = GetPrivateProfileInt(INI_SECTION, INI_APOP, 0, m_ini_path);
	GetPrivateProfileString(INI_SECTION, INI_POP3, _T(""), temp, MAX_PATH, m_ini_path);
	m_pop3 = temp;
	GetPrivateProfileString(INI_SECTION, INI_SMTP, _T(""), temp, MAX_PATH, m_ini_path);
	m_smtp = temp;
	GetPrivateProfileString(INI_SECTION, INI_MAIL_ADDRESS, _T(""), temp, MAX_PATH, m_ini_path);
	m_mail_address = temp;
}

void CvcmailnetDlg::WriteIni()
{
	TCHAR temp[_MAX_PATH];

	wsprintf(temp, _T("%d"), m_apop);
	WritePrivateProfileString(INI_SECTION, INI_APOP, temp, m_ini_path);
	WritePrivateProfileString(INI_SECTION, INI_POP3, m_pop3, m_ini_path);
	WritePrivateProfileString(INI_SECTION, INI_SMTP, m_smtp, m_ini_path);
	WritePrivateProfileString(INI_SECTION, INI_MAIL_ADDRESS, m_mail_address, m_ini_path);
}

void CvcmailnetDlg::DeleteListItem()
{
	CString *pstr;

	for(int no = 0 ; no < m_lmail.GetItemCount() ; no++) {
		pstr = (CString *)m_lmail.GetItemData(no);
		if(pstr != NULL) {
			delete pstr;
		}
	}
	m_lmail.DeleteAllItems();
}


void CvcmailnetDlg::OnUnite()
{
	CUnite dlg(this);
	
	dlg.m_folder = m_current_path;
	// WJ
	if(dlg.DoModal() == IDOK) {
	    int size;
		int ret, no;
		char temp[NMAIL_ATTACHMENT_TEMP_SIZE];
		TCHAR date[HEADER_MAX], from[HEADER_MAX];
		TCHAR header[HEADER_MAX];
		TCHAR subject[HEADER_MAX], file_name[HEADER_MAX];
		TCHAR *buff;
		TCHAR *body;
		CString html_file;
		CFile fi;

		// fR[hL
		NMailSetOption(NMAIL_OPTION_DECODE_BODY, NMAIL_DECODE_BODY_ON);
		// HTML p[gۑ
		NMailSetOption(NMAIL_OPTION_SAVE_HTML, NMAIL_SAVE_HTML_ON);

		size = 0;
        for(no = 0 ; no < dlg.m_file_list.GetSize() ; no++) {
			CFileStatus fs;
			if(CFile::GetStatus(dlg.m_file_list[no], fs)) {
				size += (int)fs.m_size;
			}
		}
		body = new TCHAR[size + 1];
		for(no = 0 ; no < dlg.m_file_list.GetSize() ; no++) {
            // Xg̃t@CԂɓǂݍ
			if(fi.Open(dlg.m_file_list[no], CFile::modeRead)) {
				size = (int)fi.GetLength();
				buff = new TCHAR[size + 1];
				fi.Read(buff, size);
				buff[size / sizeof(TCHAR)] = _T('\0');
				fi.Close();
				// ŏ̃f[^H
				if(no == 0) {
					// Ytt@ČAWJJn
					ret = NMailAttachmentFileFirst(temp, subject, date, from, header, body, dlg.m_folder, file_name, buff, NULL);
				} else {
		            // Ytt@Č
			        ret = NMailAttachmentFileNext(temp, buff, NULL);
				}
				delete [] buff;
				if(ret == NMAIL_ERROR_FILE_OPEN) {
					break;
				}
			} else {
				ret = NMAIL_ERROR_FILE_OPEN;
				break;
			}
        }
        // Ytt@ČI
        NMailAttachmentFileClose(temp);
        // IH
        if(ret >= 0) {
			NMailGetHeaderField(html_file.GetBuffer(HEADER_MAX), header, _T("X-NMAIL-HTML-FILE:"), HEADER_MAX);
			html_file.ReleaseBuffer();
			if(html_file.IsEmpty()) {
				MessageBox(dlg.m_folder + _T(" ɓYtt@C ") + file_name
				  + _T(" WJ܂B\r\n\r\n:") + subject + _T("\r\n{:\r\n") + body);
			} else {
				if(MessageBox(dlg.m_folder + _T(" ɓYtt@C ") + file_name
				  + _T(" WJ܂B\r\n\r\n:") + subject + _T("\r\n{:\r\n") + body + _T("\r\nHTML t@C ") + html_file + _T("J܂H\r\n(EBXꍇ܂BӉ)"), _T("vcmailnet"), MB_YESNO) == IDYES) {
					ShellExecute(m_hWnd, _T("open"), dlg.m_folder + _T("\\") + html_file, NULL, NULL, SW_SHOW);
				}
			}
        } else if(ret == NMAIL_ERROR_FILE_OPEN) {
            MessageBox(_T("Ytt@CI[vł܂B"));
        } else if(ret == NMAIL_ERROR_PARTIAL) {
            MessageBox(_T("ꂽ[SđĂ܂"));
        }
		delete [] body;
    }
}

void CvcmailnetDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	if(m_splitter) {
		m_splitter->AdjustSize();
	}
}
